module DeleteEmb where

import HXML

deleteEmbeddingFromText text emb var
	|(null list) = (Tree (TXNode "empty text") [])
	|otherwise = (head list)
	where
	(list,_) = deleteEmbFromText text emb var

deleteEmbFromText text emb [] = case (text,emb) of
	((Tree (ELNode tLabel []) tArgs),(Tree (ELNode eLabel []) eArgs))
		|(preT==preE) && (null eArgs) -> ([],[])
		|(preT==preE) || (eLabel == "and^1^0") || (eLabel == "or^1^0") || (eLabel == "xor^1^0") -> let (delSons,_) = delAux tArgs eArgs [] in ((makeT tLabel delSons),[])
		|otherwise -> let (sons,_) = findNode tArgs emb [] in ([(Tree (ELNode tLabel []) sons)],[])
		where
		preT = getLabelComponent tLabel 2
		preE = getLabelComponent eLabel 3
	((Tree (TXNode tLabel) []),(Tree (ELNode eLabel []) eArgs)) -> ([text],[])
	((Tree (ELNode tLabel []) tArgs),(Tree (TXNode eLabel) []))
		|preT==preE -> ([],[])
		|otherwise -> let (sons,_) = findNode tArgs emb [] in ([(Tree (ELNode tLabel []) sons)],[])
		where
		preT = getLabelComponent tLabel 2
		preE = getLabelComponent eLabel 3
	((Tree (TXNode tLabel) []),(Tree (TXNode eLabel) []))
		|preT==preE -> ([],[])
		|otherwise -> ([text],[])
		where
		preT = getLabelComponent tLabel 2
		preE = getLabelComponent eLabel 3
	
deleteEmbFromText text emb (v:vs) = case (text,emb) of
	((Tree (ELNode tLabel []) tArgs),(Tree (ELNode eLabel []) eArgs))
		|(preT==preE) && (preV==preEQ) -> let (delSons,nvar) = delAux tArgs (eArgs++vars) vs in ((makeT tLabel delSons),nvar)
		|(preT==preE) && (preV<preEQ) -> deleteEmbFromText text emb vs
		|(preT==preE) && (null eArgs) -> ([],(v:vs))
		|(preT==preE) || (eLabel == "and^1^0") || (eLabel == "or^1^0") || (eLabel == "xor^1^0") -> let (delSons,nvar) = delAux tArgs eArgs (v:vs) in ((makeT tLabel delSons),nvar)
		|otherwise -> let (sons,nvar) = findNode tArgs emb (v:vs) in ([(Tree (ELNode tLabel []) sons)],nvar)
		where
		preEQ = read (getLabelComponent eLabel 2) ::Int
		preT = read (getLabelComponent tLabel 2) ::Int
		preE = read (getLabelComponent eLabel 3) ::Int
	((Tree (TXNode tLabel) []),(Tree (ELNode eLabel []) eArgs)) -> ([text],(v:vs))
	((Tree (ELNode tLabel []) tArgs),(Tree (TXNode eLabel) []))
		|(preT==preE) && (preV==preEQ) -> let (delSons,_) = delAux tArgs vars [] in ((makeT tLabel delSons),vs)
		|(preT==preE) && (preV<preEQ) -> deleteEmbFromText text emb vs
		|preT==preE -> ([],(v:vs))
		|otherwise -> let (sons,nvar) = findNode tArgs emb (v:vs) in ([(Tree (ELNode tLabel []) sons)],nvar)
		where
		preEQ = read (getLabelComponent eLabel 2) ::Int
		preT = read (getLabelComponent tLabel 2) ::Int
		preE = read (getLabelComponent eLabel 3) ::Int
	((Tree (TXNode tLabel) []),(Tree (TXNode eLabel) []))
		|preT==preE -> ([],(v:vs))
		|otherwise -> ([text],(v:vs))
		where
		preT = read (getLabelComponent tLabel 2) ::Int
		preE = read (getLabelComponent eLabel 3) ::Int
	where
	(prev,vars) = v
	preV = read prev ::Int

makeT l s
	|(null s) = []
	|otherwise = [(Tree (ELNode l []) s)]

findNode [] _ var = ([],var)
findNode [t] emb var = deleteEmbFromText t emb var
findNode (t1:t2:ts) emb var
	|preE<preT2 = (t++(t2:ts),v)
	|otherwise = ((t1:ft),fv)
	where
	(t,v) = deleteEmbFromText t1 emb var
	(ft,fv) = findNode (t2:ts) emb var
	preE = read (getfromLabel emb 3) ::Int
	preT2 = read (getfromLabel t2 2) ::Int

delAux [] _ var = ([],var)
delAux textSons [] var = (textSons,var)
delAux textSons (e:es) var = (nFinalSons,finalVar)
	where
	(nTextSons,nvar) = findNode textSons e var
	(nFinalSons,finalVar) = delAux nTextSons es nvar

getfromLabel t i = case t of
	(Tree (ELNode label _) _) -> getLabelComponent label i
	(Tree (TXNode label) []) -> getLabelComponent label i

getLabelComponent [] 1 = []
getLabelComponent (x:xs) n
	|n==1 && x=='^' = []
	|n==1 = x:(getLabelComponent xs n)
	|x=='^' = getLabelComponent xs (n-1)
	|otherwise = getLabelComponent xs n