module ExtendQuery where

import HXML
import MyParser

type SumDelCost = [(String,Int)]

viewAll nTree mapp sdc vars types b = do {putStrLn ((show nTree)++"\nMapping:");
					mymap viewM1 mapp;
					putStrLn ("SumDelCost:");
					mymap viewSDC sdc;
					putStrLn ("Variables:");
					mymap viewM1 vars;
					putStrLn ("\n");
					putStrLn ("Search type:");
					mymap viewM1 types;
					putStrLn (show b);
				}
 
pippo tree i = viewAll nTree mapp sdc vars types b
	where (nTree,mapp,sdc,vars,types,b) = extendQuery tree i

pluto tree i = viewAll nTree mapp [("2","5")] vars types a
	where (nTree,mapp,vars,types,a) = visitQuery tree i

viewM1 (i,n) = putStr ("("++i++", "++n++") ")
viewSDC (n,i) = putStr ("("++n++", "++(show i)++") ")

extendQuery::Tree XMLNode->Int->(Tree XMLNode,MPtL String,SumDelCost,[Var],MPtL String,Int)
extendQuery (Tree (ELNode label []) args) pre
	|(length args)==0 = ((Tree (ELNode (show pre) []) []),[((show pre),label)],[],[],[],pre)
	|otherwise = ((Tree (ELNode (show pre) []) sons),(((show pre),label):nMapp),nSdc,nVar,nType,b)
	where
	(sons, nMapp, nSdc, nVar, nType, b) = verifyDepth (head args) [] [] [] [] (pre+1)
extendQuery (Tree (ELNode label atts) args) pre
	|(length args)==0 = ((Tree (ELNode (show pre) []) []),[((show pre),label)],[],var,typ,pre)
	|otherwise = ((Tree (ELNode (show pre) []) sons),(((show pre),label):nMapp),nSdc,fVar,fType,b)
	where
	(var,typ) = getVarandType (show pre) atts [] [] 0
	(fVar,fType) = getVarandType (show pre) atts nVar nType 0
	(sons, nMapp, nSdc, nVar, nType, b) = verifyDepth (head args) [] [] [] [] (pre+1)
extendQuery (Tree (TXNode label) []) pre = ((Tree (TXNode (show pre)) []),[((show pre),label)],[],[],[],pre)

extendAux::Tree XMLNode->MPtL String->SumDelCost->[Var]->MPtL String->Int->Int->(Tree XMLNode,MPtL String,SumDelCost,[Var],MPtL String,Int,Int)
extendAux tree mapp sdc vars types pre cost = case tree of
	(Tree (TXNode label) []) -> let nsdc = (addSDC pre cost sdc) in ((Tree (TXNode (show pre)) []),(((show pre),label):mapp),nsdc,vars,types,pre,1)
	(Tree (ELNode label atts) args) 
		|(label == "and") -> let (sons,nMapp,nSdc,nvars,ntypes,bound) = extendMap args mapp sdc vars types (pre+1) cost
					 nSdc2 = addSDC pre cost nSdc
				     in ((Tree (ELNode (show pre) []) sons),(((show pre),label):nMapp),nSdc2,nvars,ntypes,(bound-1),0)
		|(label == "or") -> let (sons,nMapp,nSdc,nvars,ntypes,bound) = extendMap args mapp sdc vars types (pre+1) cost
					nSdc2 = addSDC pre cost nSdc
				    in ((Tree (ELNode (show pre) []) sons),(((show pre),label):nMapp),nSdc2,nvars,ntypes,(bound-1),0)
		|(label == "xor") -> let (sons,nMapp,nSdc,nvars,ntypes,bound) = extendMap args mapp sdc vars types (pre+1) cost
					 nSdc2 = addSDC pre cost nSdc
				     in ((Tree (ELNode (show pre) []) sons),(((show pre),label):nMapp),nSdc2,nvars,ntypes,(bound-1),0)
		|(null args) -> let 	nsdc = addSDC pre cost sdc
					(nvars,ntypes) = getVarandType (show pre) atts vars types 0
				in ((Tree (ELNode (show pre) []) []),(((show pre),label):mapp),nsdc,nvars,ntypes,pre,1)
		|otherwise -> let	(son1,nm,nsdc,nvars,ntypes,b) = verifyDepth (head args) mapp sdc vars types (pre+2)
					(son2,nm2,nsdc2,nvars2,ntypes2,b2,num) = extendAux (head args) nm nsdc vars types (b+1) delcost
					nsdc3 = addSDC pre cost nsdc2
					dvars2 = markDuplicate nvars2
					vars3 = nvars++dvars2
					types3 = ntypes++ntypes2
					(fvars,ftypes) = getVarandType (show (pre+1)) atts vars3 types3 0
			      in ((Tree (ELNode (show pre) []) [(Tree (ELNode (show (pre+1)) []) son1),son2]),(((show pre),"or"):(((show (pre+1)),label):nm2)),nsdc3,fvars,ftypes,b2,num+1)

extendMap::[Tree XMLNode]->MPtL String->SumDelCost->[Var]->MPtL String->Int->Int->([Tree XMLNode],MPtL String,SumDelCost,[Var],MPtL String,Int)
extendMap [] mapp sdc vars types pre _ = ([],mapp,sdc,vars,types,pre)
extendMap (x:xs) mapp sdc vars types pre cost = (t:ts,nm2,nsdc2,nvars++nvars2,ntypes++ntypes2,b2)
	where
	(t,nm,nsdc,nvars,ntypes,b,_) = extendAux x mapp sdc vars types pre cost
	(ts,nm2,nsdc2,nvars2,ntypes2,b2) = extendMap xs nm nsdc vars types (b+1) cost
{-
extendMap::[Tree XMLNode]->MPtL String->SumDelCost->[Var]->MPtL String->Int->Int->Int->Int->([Tree XMLNode],MPtL String,SumDelCost,[Var],MPtL String,Int)
extendMap [] mapp sdc vars types pre _ _ _ = ([],mapp,sdc,vars,types,pre)
extendMap (x:xs) mapp sdc vars types pre cost applicant numVar 
	|applicant == 1 = (t:ts,nm2,nsdc2,nvars++nvars2,ntypes++ntypes2,b2)
	|(applicant == 0) && (numVar == 0) && (lnvar == lvar) = (t:ts,nm2,nsdc2,nvars++nvars2,ntypes++ntypes2,b2)
	|(applicant == 0) && (((numVar == 0) && (lnvar > lvar)) || ((numVar == 1) && (lnvar == lvar))) = (t:ts3,nm3,nsdc3,nvars++nvars3,ntypes++ntypes3,b3)
	|(applicant == 0) && (lnvar > lvar) = error ("Malformed query: founded variables in more than one branch of or/xor")
	where
	lvar = length vars
	lnvar = length nvars
	(t,nm,nsdc,nvars,ntypes,b,_) = extendAux x mapp sdc vars types pre cost
	(ts,nm2,nsdc2,nvars2,ntypes2,b2) = extendMap xs nm nsdc vars types (b+1) cost applicant numVar
	(ts3,nm3,nsdc3,nvars3,ntypes3,b3) = extendMap xs nm nsdc vars types (b+1) cost applicant 1
-}

verifyDepth::Tree XMLNode->MPtL String->SumDelCost->[Var]->MPtL String->Int->([Tree XMLNode],MPtL String,SumDelCost,[Var],MPtL String,Int)
verifyDepth tree mapp sdc vars types pre = case tree of
	(Tree (TXNode label) []) -> ([(Tree (TXNode (show pre)) [])],(((show pre),label):mapp),sdc,vars,types,pre)
	(Tree (ELNode label atts) args) -> let (nTree,nm,nsdc,nvars,ntypes,b,_) = (extendAux tree mapp sdc vars types pre 0) in ([nTree],nm,nsdc,nvars,ntypes,b)

{-
in extendAux c'era:
	|(label == "and") -> extendAnd (divideArgs args) mapp sdc vars types pre cost

extendAnd::([Tree XMLNode],[Tree XMLNode])->MPtL String->SumDelCost->[Var]->MPtL String->Int->Int->(Tree XMLNode,MPtL String,SumDelCost,[Var],MPtL String,Int,Int)
extendAnd (sons, leaves) mapp sdc vars types pre cost
	|((length sons) == 1) && ((length leaves) == 0) = extendAux (head sons) mapp sdc vars types pre cost
	|((length sons) > 0) && ((length leaves) == 0) = let 	(son1,m1,sdc1,vars1,types1,b1,num1) = extendAux (head sons) mapp sdc vars types (pre+2) cost
								(son2,m2,sdc2,vars2,types2,b2,num2) = extendAnd ((tail sons),[]) m1 sdc1 vars types (b1+1) cost
								(son3,m3,sdc3,vars3,types3,b3,_) = extendAux (head sons) m2 sdc2 vars types (b2+2) (cost+(5*num2))
								(son4,m4,sdc4,vars4,types4,b4,_) = extendAnd ((tail sons),[]) m3 sdc3 vars types (b3+1) (cost+(5*num1))
								dvars3 = markDuplicate vars3
								dvars4 = markDuplicate vars4
								fvars = vars1++(vars2++(dvars3++dvars4))
								ftypes = types1++(types2++(types3++types4))
								finalSdc = addSDC pre cost (addSDC (pre+1) cost (addSDC (b2+1) cost sdc4))
							 in ((Tree (ELNode (show pre) []) [(Tree (ELNode (show (pre+1)) []) [son1,son2]),(Tree (ELNode (show (b2+1)) []) [son3,son4])]),(((show pre),"or"):(((show (pre+1)),"and"):(((show (b2+1)),"or"):m4))),finalSdc,fvars,ftypes,b4,num1+num2)
	|((length sons) == 0) && ((length leaves) == 1) = extendAux (head leaves) mapp sdc vars types pre cost
	|((length sons) == 0) && ((length leaves) > 0) = let 	(sons,nmap,nsdc,nvars,ntypes,b) = extendMap leaves mapp sdc vars types (pre+1) 0 1 0
								nsdc2 = addSDC pre cost nsdc
							 in ((Tree (ELNode (show pre) []) sons),(((show pre),"and"):nmap),nsdc2,nvars,ntypes,(b-1),(length leaves))
	|((length sons) > 1) && ((length leaves) > 0) = let 	(son1,nm,nsdc,nvars,ntypes,b,num) = (extendAnd (sons,[]) mapp sdc vars types (pre+1) cost) 
								(nLeaves,nm2,nsdc2,nvars2,ntypes2,b2) = extendMap leaves nm nsdc vars types (b+1) cost 1 0
								fvars = nvars++nvars2
								ftypes = ntypes++ntypes2
								nsdc3 = addSDC pre cost nsdc2
							in ((Tree (ELNode (show pre) []) (son1:nLeaves)),(((show pre),"and"):nm2),nsdc3,fvars,ftypes,(b2-1),num+(length leaves))
	|((length sons) == 1) && ((length leaves) > 0) = let 	(son,m1,sdc1,vars1,types1,b1,num) = extendAux (head sons) mapp sdc vars types (pre+2) cost
								(nl1,m2,sdc2,vars2,types2,b2,numL) = extendAnd ([],leaves) m1 sdc1 vars types (b1+1) cost
								(nl2,m3,sdc3,vars3,types3,b3,_) = extendAnd ([],leaves) m2 sdc2 vars types (b2+1) (cost+(num*5))
								dvars3 = markDuplicate vars3
								fvars = vars1++(vars2++dvars3)
								ftypes = types1++(types2++types3)
								finalSdc = addSDC pre cost (addSDC (pre+1) cost sdc3)
							 in ((Tree (ELNode (show pre) []) [(Tree (ELNode (show (pre+1)) []) [son,nl1]),nl2]),(((show pre),"or"):(((show (pre+1)),"and"):m3)),finalSdc,fvars,ftypes,b3,num+numL)
-}

visitQuery::Tree XMLNode->Int->(Tree XMLNode,MPtL String,[Var],MPtL String,Int)
visitQuery (Tree (ELNode label []) args) pre = case label of
	"and" -> let (sons,nMapp,nvars,ntypes,bound) = visitMap args (pre+1)
		 in ((Tree (ELNode (show pre) []) sons),(((show pre),"and"):nMapp),nvars,ntypes,(bound-1))
	"or" -> let (sons,nMapp,nvars,ntypes,bound) = visitMap args (pre+1)
		in ((Tree (ELNode (show pre) []) sons),(((show pre),"or"):nMapp),nvars,ntypes,(bound-1))
	"xor" -> let (sons,nMapp,nvars,ntypes,bound) = visitMap args (pre+1)
		in ((Tree (ELNode (show pre) []) sons),(((show pre),"xor"):nMapp),nvars,ntypes,(bound-1))
	otherwise 
		|(length args) == 0 -> ((Tree (ELNode (show pre) []) []),[((show pre),label)],[],[],pre)
		|(length args) > 0 -> let (sons, nMapp, nVar, nType, bound) = visitQuery (head args) (pre+1)
		     		      in ((Tree (ELNode (show pre) []) [sons]),(((show pre),label):nMapp),nVar,nType,bound)

visitQuery (Tree (ELNode label atts) args) pre
	|(length args)==0 = ((Tree (ELNode (show pre) []) []),[((show pre),label)],var,typ,pre)
	|otherwise = ((Tree (ELNode (show pre) []) [sons]),(((show pre),label):nMapp),fVar,fType,bound)
	where
	(var,typ) = getVarandType (show pre) atts [] [] 0
	(fVar,fType) = getVarandType (show pre) atts nVar nType 0
	(sons, nMapp, nVar, nType, bound) = visitQuery (head args) (pre+1)
	
visitQuery (Tree (TXNode label) []) pre = ((Tree (TXNode (show pre)) []),[((show pre),label)],[],[],pre)

visitMap::[Tree XMLNode]->Int->([Tree XMLNode],MPtL String,[Var],MPtL String,Int)
visitMap [] pre = ([],[],[],[],pre)
visitMap (x:xs) pre = (t:ts,nm++nm2,nvars++nvars2,ntypes++ntypes2,b2)
	where
	(t,nm,nvars,ntypes,b) = visitQuery x pre
	(ts,nm2,nvars2,ntypes2,b2) = visitMap xs (b+1)

{-
visitMap::[Tree XMLNode]->Int->Int->Int->([Tree XMLNode],MPtL String,[Var],MPtL String,Int)
visitMap [] pre _ _ = ([],[],[],[],pre)
visitMap (x:xs) pre applicant numVar
	|(applicant == 1) = (t:ts,nm++nm2,nvars++nvars2,ntypes++ntypes2,b2)
	|(applicant == 0) && (numVar == 0) && (lvar == 0) = (t:ts,nm++nm2,nvars++nvars2,ntypes++ntypes2,b2)
	|(applicant == 0) && (((numVar == 0) && (lvar > 0)) || ((numVar == 1) && (lvar == 0))) = (t:ts3,nm++nm3,nvars++nvars3,ntypes++ntypes3,b3)
	|(applicant == 0) && (numVar == 1) && (lvar > 0) = error ("Malformed query: founded variables in more than one branch of or/xor")
	where
	lvar = length nvars
	(t,nm,nvars,ntypes,b) = visitQuery x pre
	(ts,nm2,nvars2,ntypes2,b2) = visitMap xs (b+1) applicant numVar
	(ts3,nm3,nvars3,ntypes3,b3) = visitMap xs (b+1) applicant 1
-}
divideArgs::[Tree XMLNode]->([Tree XMLNode],[Tree XMLNode])
divideArgs [] = ([],[])
divideArgs (x:xs) = case x of
	(Tree (ELNode _ _) args) 
		|(null args) -> (ns,x:nl)
		|otherwise -> (x:ns,nl)
	(Tree (TXNode _) _) -> (ns,x:nl)
	where
	(ns,nl) = divideArgs xs
	
getSDC::String->SumDelCost->Int
getSDC _ [] = 0
getSDC label (s:sdc)
	|label==n = c
	|otherwise = getSDC label sdc
	where
	(n,c) = s

addSDC::Int->Int->SumDelCost->SumDelCost
addSDC label cost sdc
	|cost == 0 = sdc
	|otherwise = ((show label),cost):sdc

getVarandType::String->[Var]->[Var]->MPtL String->Int->([Var],MPtL String)
getVarandType pre [] vs ts i 
	|i<=1 = (vs,ts)
	|i==2 = error ("Multiple variable at node "++(show pre))
getVarandType pre atts _ _ _
	|(length atts)>2 = error ("Multiple variable at node "++(show pre))
getVarandType pre (a:as) vs ts i
	|att=="type" = getVarandType pre as vs ((pre,value):ts) i
	|att=="var"  = getVarandType pre as ((pre,value):vs) ts (i+1)
	where
	(att,value)=a

markDuplicate::[Var]->[Var]
markDuplicate [] = []
markDuplicate (v:vs)
	|l==1 = (pre,('C':var)):(markDuplicate vs)
	|l>1 = v:(markDuplicate vs)
	where
	(pre,var)=v
	l = length var